*******************************************************************************
*                      68000/68010 Grundprogramm grafcol                      *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2007 Jens Mewes                                 *
*                                 Rev 7.00                                    *
*                                01.09.2007                                   *
*                Grafik-Paket fr GDP und COL256   ( COL-Routinen )           *
*******************************************************************************

gr2p0:                          * Punkt setzen mit Randberwachung
 cmp #511,d2
 bhi.s gr2p0a                   * Auerhalb des Bereichs
 cmp #511,d1
 bhi.s gr2p0a                   * Auerhalb des Bereichs
 movem.l d1/d2/a4,-(a7)
 asr #1,d2                      * Bildschirmaufbau beachten
 movea.l colpadr(a5),a6         * Adresse der Punkt-Setz-Routine
 bsr colpoint                   * Punkt ausgeben
 movem.l (a7)+,d1/d2/a4
gr2p0a:
rts

gr2p1:                          * Linie ziehen
 movem.l d0-d6/a4,-(a7)
 asr #1,d2                      * Wegen Bildschirmformat
 asr #1,d4
 bsr coldraw                    * Linie ziehen
 movem.l (a7)+,d0-d6/a4
rts

gr2p2:                          * Linienfolge
 movem.l d0-d6/a4,-(a7)
 move (a0)+,d7                  * Anzahl der Punkte
 subq #2,d7                     * -2 wegen DBRA und erstem Punkt
gr2p2a:
 movem.w (a0),d1-d4             * Anfangspunkt und Endpunkt Linie
 addq.l #4,a0
 asr #1,d2                      * Wegen Bildschirmformat
 asr #1,d4                      * Wegen Bildschirmformat
 move d7,-(a7)
 bsr coldraw                    * Linie ziehen
 move (a7)+,d7
dbra d7,gr2p2a                  * Wiederholen
 movem.l (a7)+,d0-d6/a4
rts

gr2p3:                          * Quadrat leer
 movem.l d3/d4/a0,-(a7)
 move d3,d4                     * Wie Rechteck leer mit gleichen Seitenlngen
 bsr gr2u1
 movem.l (a7)+,d3/d4/a0
rts

gr2p4:                          * Quadrat voll
 movem.l d0-d6/a4,-(a7)
 move d3,d4                     * Wie Rechteck voll mit gleichen Seitenlngen
bra.s gr2p60

gr2p5:                          * Rechteck leer
 movem.l d3/d4/a0,-(a7)
 bsr gr2u1
 movem.l (a7)+,d3/d4/a0
rts

gr2p6:                          * Rechteck voll
 movem.l d0-d6/a4,-(a7)         * Wie gr2u1 aber ausgefllt
gr2p60:
 add d1,d3
 asr #1,d2                      * Wegen Bildschirmformat
 asr #1,d4
 beq.s gr2p6a                   * Wenn Hhe gleich 0, dann weiter
 subq #1,d4                     * Sonst minus 1 wegen DBRA
gr2p6a:                         * Hhe 0 und Hhe 1 sind jeweils eine Linie
 bsr gr2xline                   * Linie parallel zur X-Achse ziehen
 addq #1,d2                     * Y-Position erhhen
dbra d4,gr2p6a
 movem.l (a7)+,d0-d6/a4
rts

gr2p7:                          * Kreis leer
 movem.l d0-d6/a0-a4,-(a7)
 move d3,d4
 bsr gr2u2                      * Wie Elipse leer mit gleichen Radien
 movem.l (a7)+,d0-d6/a0-a4
rts

gr2p8:                          * Kreis ausgefllt
 movem.l d0-d6/a0-a4,-(a7)
 move d3,d4
 bsr gr2u3                      * Wie Elipse ausgefllt mit gleichen Radien
 movem.l (a7)+,d0-d6/a0-a4
rts

gr2p9:                          * Elipse leer
 movem.l d0-d6/a0-a4,-(a7)
 bsr gr2u2
 movem.l (a7)+,d0-d6/a0-a4
rts

gr2p10:                         * Elipse ausgefllt
 movem.l d0-d6/a0-a4,-(a7)
 bsr gr2u3
 movem.l (a7)+,d0-d6/a0-a4
rts

                                * Nicht mit Schwarz und XOR fllen !!!
gr2p11:                         * Flche fllen
 cmp #511,d2
 bhi carset                     * Auerhalb des Bereichs
 cmp #511,d1
 bhi carset                     * Auerhalb des Bereichs
 movem.l d0-d6/a4,-(a7)
 asr #1,d2                      * Y-Koordinate durch 2 teilen
 move.b colcol2(a5),d6
 bsr gr2p11h                    * Hat der erste Punkt die Fll-Farbe ?
 beq.s gr2p11fi                 * Ja, dann Ende
 move.b d7,d6
 move #512,d5                   * Rechte Grenze
 move #-1,-(a7)                 * Endekennung Eckpunkte
 move d1,d3                     * X-Koordiante auch
 bsr.s gr2p11e                  * Linke Grenze holen
 movem.w d1/d2,-(a7)            * Merken (Auch Y-Koordinate)
 move d3,d1                     * X zurck
 bsr gr2p11f                    * Rechte Grenze holen
 move d1,-(a7)                  * Merken
gr2p11a:                        * Schleife
 move (a7)+,d3                  * Rechte Grenze vom Stack holen
 bmi.s gr2p11fi                 * Negativ, dann Stack leer und Ende
 movem.w (a7)+,d1/d2            * Linke Grenze und Y-Koordinate vom Stack holen
 bsr gr2p11h                    * Aktuellen Punkt testen
 bne.s gr2p11a                  * Schon gefllt, dann weiter
 bsr gr2xla1                    * Linie ziehen
 move d1,d4                     * d1 merken
 addq.b #1,d2                   * Eine Reihe hoch
 beq.s gr2p11c                  * Obere Grenze erreicht
 bsr.s gr2p11e                  * Nach links, bis Farben ungleich
gr2p11b:
 bsr gr2p11g                    * Jetzt linke Grenze holen
 bcs.s gr2p11c                  * Fehler, keine linke Grenze gefunden
 movem.w d1/d2,-(a7)            * Werte merken
 bsr.s gr2p11f                  * Rechte Grenze holen
 move d1,-(a7)                  * Merken
 addq #1,d1                     * X-Koordinate erhhen
 cmp d1,d3                      * Nicht ber rechte Grenze hinaus
 bhi.s gr2p11b
gr2p11c:
 subq.b #2,d2                   * Eine Reihe tiefer (addq #1,d2 ausgleichen)
 cmp.b #255,d2                  * berlauf ?
 beq.s gr2p11a                  * Ja, dann nchste Linie
 move d4,d1                     * d1 zurck
 bsr.s gr2p11e                  * Und wie oben
gr2p11d:
 bsr gr2p11g
 bcs.s gr2p11a
 movem.w d1/d2,-(a7)
 bsr.s gr2p11f
 move d1,-(a7)
 addq #1,d1
 cmp d1,d3
 bhi.s gr2p11d
bra.s gr2p11a
gr2p11fi:
 movem.l (a7)+,d0-d6/a4         * Register zurck
bra carres                      * OK

gr2p11e:                        * Nach links bis Bildschirmfarbe wechselt
 bsr gr2p11h                    * Ersten Punkt holen fr Anfangsadresse
 bne.s gr2p11e3                 * Ungleich, dann fertig
 subq #1,d1                     * d1 nach links
 bmi.s gr2p11e4                 * Negativ, dann auch Ende
 lsl.b #1,d7                    * d7 ist gleiche Farbe wie d6 aber fr zweiten
 btst.b #0,d1                   * Punkt
 bne.s gr2p11e2                 * Auswahl, gerade oder ungerade
gr2p11e1:
 move.b (a4),d0                 * Zwei Punkte holen
 and.b #%10101010,d0            * Nur Vorderen lassen
 cmp.b d7,d0                    * Immer noch gleich ?
 bne.s gr2p11e3                 * Nein, dann Ende
 subq #1,d1                     * Sonst weiter nach links suchen
 bmi.s gr2p11e4                 * Ende, da ganz links
gr2p11e2:
 subq.l #cpu,a4
 move.b (a4),d0                 * Nchsten Punkt holen
 and.b #%01010101,d0            * Wie oben
 cmp.b d6,d0
 bne.s gr2p11e3
 subq #1,d1
bra.s gr2p11e1
gr2p11e3:
 cmp #511,d1                    * Ganz rechts, dann weiter
 beq.s gr2p11e5
gr2p11e4:
 addq #1,d1                     * Sonst +1
gr2p11e5:
rts

gr2p11f:                        * Wie gr2p11e, aber nach rechts suchen
 bsr gr2p11h
 bne.s gr2p11f3
 addq #1,d1
 cmp d5,d1
 beq.s gr2p11f3
 lsl.b #1,d7
 btst.b #0,d1
 bne.s gr2p11f2
gr2p11f1:
 addq.l #cpu,a4
 move.b (a4),d0
 and.b #%10101010,d0
 cmp.b d7,d0
 bne.s gr2p11f3
 addq #1,d1
gr2p11f2:
 move.b (a4),d0
 and.b #%01010101,d0
 cmp.b d6,d0
 bne.s gr2p11f3
 addq #1,d1
 cmp d5,d1
 bne.s gr2p11f1
gr2p11f3:
 subq #1,d1
rts

gr2p11g:                        * Wie gr2p11f, aber andere Abbruchbedingung
 move d1,-(a7)                  * Es wird die linke Grenze gesucht
gr2p11g0:
 bsr.s gr2p11h                  * Linke Grenze suchen
 beq.s gr2p11g4                 * OK, gefunden
 addq #1,d1                     * 1 dazu
 cmp d5,d1                      * Rechte Grenze erreicht ?
 beq.s gr2p11g3                 * Nein, dann weitersuchen
 move.b d6,d7
 lsl.b #1,d7
 btst #0,d1
 bne.s gr2p11g2
gr2p11g1:
 addq.l #cpu,a4
 move.b (a4),d0
 and.b #%10101010,d0
 cmp.b d7,d0
 beq.s gr2p11g4
 addq #1,d1
gr2p11g2:
 move.b (a4),d0
 and.b #%01010101,d0
 cmp.b d6,d0
 beq.s gr2p11g4
 addq #1,d1
 cmp d5,d1
 bne.s gr2p11g1
gr2p11g3:
 addq.l #2,a7                   * Stack abbauen
bra carset                      * Fehler, keine linke Grenze gefunden
gr2p11g4:
 move (a7)+,d0                  * Anfangsprfpunkt nach d0
 cmp d3,d1                      * ber rechte Grenze hinaus ?
 bhi carset                     * Ja, Fehler
 cmp d0,d1                      * Gefundene Grenze links der alten Position ?
 bpl carres                     * Nein, dann weiter
 move d0,d1                     * Ja, deshalb vom alten Wert an suchen, weil
bra carres                      * dann einige Punkte eingespart werden
                                * OK, Linke Grenze korrekt gefunden

gr2p11h:                        * Einen Punkt prfen
 move d2,d7
 move d1,d0
 movea.l colram(a5),a4          * Basis-Adresse (Wird spter multipliziert)
 not.b d7                       * Y-Koordinate umdrehen
 ror #6,d7                      * Seite ermitteln
 or.b colwpage(a5),d7           * Schreibseite dazu
 move.b d7,colpage.w            * Einstellen
 lsr #2,d7                      * Seite verschwinden lassen
 lsr #1,d0                      * X-Koordinate durch Zwei teilen
 bcs.s gr2p11h1                 * Gerade oder Ungerade ?
 move.b d0,d7                   * X-Koordinate addieren
 adda d7,a4                     * Adresse berechnet
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b (a4),d7                 * Punkt holen
 and.b #%10101010,d7            * Nur ersten Punkt lassen
 lsr.b #1,d7                    * Nach rechts schieben
 cmp.b d6,d7                    * Vergleich der Punkte
rts
gr2p11h1:
 move.b d0,d7                   * X-Koordinate addieren
 adda d7,a4                     * Adresse berechnet
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b (a4),d7                 * Punkt holen
 and.b #%01010101,d7            * Nur zweiten Punkt lassen
 cmp.b d6,d7                    * Vergleich
rts

gr2p12:                         * Seite in aktueller Farbe lschen ohne XOR
 movem.l d0-d2,-(a7)            * ==> Nur fr 68000/68010
 move.b colcol1(a5),d0          * Farbe
 or.b colcol2(a5),d0            * Zusammensetzen
 move.b colwpage(a5),d1         * Erste Seite
 moveq #4-1,d2                  * 4 16-Kbyte-Seiten
gr2p12a:
 move.b d1,colpage.w            * Seite einstellen
 addq.b #1,d1                   * Seite erhhen
 movea.l colram(a5),a6          * Adresse Speicher
 adda.l a6,a6                   * ==> Nur fr 68000/68010
 move #16*1024-1,d7             * 16 Kbyte
gr2p12b:
 move.b d0,(a6)                 * Zwei Punkte lschen
 addq.l #cpu,a6                 * Nchste Adresse
dbra d7,gr2p12b
dbra d2,gr2p12a
 movem.l (a7)+,d0-d2
rts

gr2p13:                         * Seite COL setzen
 move d1,d7
 and #3,d7
 move.b d7,colvpage(a5)         * d1 = Lese d2 = Schreibseite
 move d2,d7
 and #3,d7
 lsl.b #2,d7
 or.b #$80,d7                   * COL einschalten
 move.b d7,colwpage(a5)         * Seiten merken
bra colinit2                    * Seite einstellen

gr2p14:                         * Seite abfragen
 moveq #0,d1
 move.b colvpage(a5),d1         * d1.b ist Leseseite
 moveq #0,d2
 move.b colwpage(a5),d2         * Schreibseite
 and.b #$7f,d2                  * Bit lschen
 lsr.b #2,d2                    * d2.b ist Schreibseite
rts

gr2p15:                         * Schreibfarbe + Verknpfungsmode einstellen
                                * Ergebnis d1 = Farbe als Bits fr COL kodiert
 and #$f,d1                     * 0 bis 15
 move.b d1,colcolor(a5)         * Farbe merken
 move.b colcoltab(pc,d1),d1     * Ergebnis Farbe in d1
 move.b d1,colcol1(a5)          * Farbe Teil 1 merken
 lsr.b #1,d1                    * Schieben fr zweiten Punkt
 move.b d1,colcol2(a5)          * Farbe Teil 2 merken
 lea colpset(pc),a6             * Adresse SETZEN
 move.b d2,d7
 and.b #1,d7                    * Nur 0 und 1
 move.b d7,colxor(a5)           * XOR-Mode merken
 beq.s gr2p15a
 lea colpxor(pc),a6             * Adresse XOR-Verknpfung
gr2p15a:
 move.l a6,colpadr(a5)          * Adresse merken
rts

colcoltab:                      * Tabelle der Farben
 dc.b %00000000                 * Schwarz
 dc.b %10101010                 * Wei
 dc.b %10001010                 * Gelb
 dc.b %10001000                 * Grn
 dc.b %10000010                 * Rot
 dc.b %10100000                 * Blau
 dc.b %10100010                 * Violett
 dc.b %10101000                 * Zyan
 dc.b %10000000                 * Dunkelgrau
 dc.b %00101010                 * Hellgrau
 dc.b %00001010                 * Braun
 dc.b %00001000                 * Dunkelgrn
 dc.b %00000010                 * Dunkelrot
 dc.b %00100000                 * Dunkelblau
 dc.b %00101000                 * Zyan dunkel
 dc.b %00100010                 * Violett dunkel

gr2p16:                         * Farbe und Verknpfungsmode abfragen
 moveq #0,d2                    * Langwort gltig
 move.b colxor(a5),d2           * d2.b ist Verknpfungsmode (0/1)
 moveq #0,d1                    * Langwort gltig
 move.b colcolor(a5),d1         * In d1.b ist Farbe
rts

gr2p17:                         * Scroll setzen
 move d1,d7
 and #$0ffc,d7                  * Nur in Viererschritten mglich
 move d7,colscroll(a5)          * Wert merken
bra colinit2                    * Scroll einstellen

gr2p18:                         * Scrollwert abfragen
 moveq #0,d1                    * d1.l ist gltig
 move.w colscroll(a5),d1        * Scrollwert nach d1.w
rts

gr2p19:                         * Einen Punkt auslesen mit Randberwachung
 cmp #511,d2
 bhi carset                     * Auerhalb des Bereichs
 cmp #511,d1
 bhi carset                     * Auerhalb des Bereichs
 moveq #0,d3                    * Byte innerhalb Langwort gltig
 movem.l d1/a4,-(a7)            * Ergebnis der Farbe steht in d3
 move d2,d7
 asr #1,d7                      * Bildschirmformat anpassen
 movea.l colram(a5),a4          * Basis-Adresse (Wird spter multipliziert)
 not.b d7                       * Y-Koordinate umdrehen
 ror #6,d7                      * Seite ermitteln
 or.b colwpage(a5),d7           * Schreibseite dazu
 move.b d7,colpage.w            * Einstellen
 lsr #2,d7                      * Seite verschwinden lassen
 lsr #1,d1                      * X-Koordinate durch zwei teilen
 bcs.s gr2p19a                  * Gerade oder Ungerade ?
 move.b d1,d7                   * X-Koordinate addieren
 adda d7,a4                     * Adresse berechnet
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b (a4),d3                 * Punkt holen
 and.b #%10101010,d3            * Nur ersten Punkt lassen
 lsr.b #1,d3                    * Nach rechts schieben
 movem.l (a7)+,d1/a4
bra carres
gr2p19a:
 move.b d1,d7                   * X-Koordinate addieren
 adda d7,a4                     * Adresse berechnet
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b (a4),d3                 * Punkt holen
 and.b #%01010101,d3            * Nur zweiten Punkt lassen
 movem.l (a7)+,d1/a4
bra carres

gr2p20:                         * Hardcopy erstellen
 movem.l d0-d1/a0,-(a7)
 move.b colwpage(a5),d0         * Erste Seite
 moveq #4-1,d1
gr2p20a:
 move.b d0,colpage.w            * Seite einstellen
 addq.b #1,d0                   * Nchste Seite
 movea.l colram(a5),a6          * Ram-Adresse COL
 adda.l a6,a6                   * ==> Nur fr 68000/68010
 move #16*1024-1,d7             * 4 16 Kbyte-Seiten
gr2p20b:
 move.b (a6),(a0)+              * Zwei Punkte holen
 addq.l #cpu,a6
dbra d7,gr2p20b
dbra d1,gr2p20a
 movem.l (a7)+,d0-d1/a0
bra carres

gr2p21:                         * Bild laden
 movem.l d0-d2/a0,-(a7)
 move.b colwpage(a5),d1         * Erste Seite
 moveq #4-1,d2
gr2p21a:
 move.b d1,colpage.w            * Seite einstellen
 addq.b #1,d1                   * Nchste Seite
 movea.l colram(a5),a6          * COL-Adresse
 adda.l a6,a6                   * ==> Nur fr 68000/68010
 move #16*1024-1,d7             * 4 16 Kbyte-Seiten
 tst.b colxor(a5)               * Mit XOR-Mode
 bne.s gr2p21c
gr2p21b:
 move.b (a0)+,(a6)              * Zwei Punkte zur COL
 addq.l #cpu,a6
dbra d7,gr2p21b
bra.s gr2p21d
gr2p21c:
 move.b (a0)+,d0                * Zwei Punkte holen
 eor.b d0,(a6)                  * Mit Punkten im Bildschirm verknpfen
 addq.l #cpu,a6
dbra d7,gr2p21c
gr2p21d:
dbra d2,gr2p21a
 movem.l (a7)+,d0-d2/a0
rts

gr2p22:                         * Bild von der GDP in Bild fr die COL wandeln
 movem.l d0-d6/a0,-(a7)
 move.b colcol2(a5),d5          * Farbe erster Teil
 move.b colcol1(a5),d6          * Farbe zweiter Teil
 movea.l a0,a6
 lea 16*1024(a0),a0             * Von hinten anfangen
 adda.l #64*1024,a6             * Dort ablegen
 move #256-1,d4                 * 256 Punkte in Y-Richtung
gr2p22a:
 moveq #512/32-1,d3             * 512 Punkte in X-Richtung
gr2p22b:
 move.l -(a0),d0                * 32 Punkte behandeln
 moveq #16-1,d2                 * 16 * 2
gr2p22c:
 clr d1                         * Dort Ziel
 ror.l #1,d0                    * Erstes Bit
 bcc.s gr2p22d                  * Nicht gesetzt
 move.b d5,d1                   * Gesetzt, deshalb Punkt fr COL
gr2p22d:
 ror.l #1,d0                    * Zweites Bit
 bcc.s gr2p22e                  * Nicht gesetzt
 or.b d6,d1                     * Gesetzt, deshalb Punkt fr COL
gr2p22e:
 move.b d1,-(a6)                * Zwei Punkte merken
dbra d2,gr2p22c
dbra d3,gr2p22b
dbra d4,gr2p22a
 movem.l (a7)+,d0-d6/a0
rts

gr2p23:                         * Textausgabe mit der COL-Karte (Wie TEXTPRINT)
 movem.l d0-d6/a0-a1/a4,-(a7)   * a0 = Text
 movea.l colpadr(a5),a6
 asr #1,d2                      * Bildschirmaufbau beachten
 move d1,-(a7)                  * X-Position merken
 move.b d3,d0                   * Gre merken
 movea.l a0,a1                  * d1 = X / d2 = Y
 and #$f,d3                     * Y-Vergrerung merken
 bne.s gr2p230                  * Nicht Null, dann OK
 moveq #16,d3                   * Null ist Vergrerung 16
gr2p230:
 mulu #10,d3                    * Mal Zeilenabstand
gr2p23a:
 clr d7                         * Wort ist ntig
 move.b (a1)+,d7                * Zeichen holen
 bmi.s gr2p23c                  * Null ist Ende
 bne.s gr2p23b
 move (a7)+,d1
 movem.l (a7)+,d0-d6/a0-a1/a4
rts
gr2p23b:
 cmp.b #$a,d7                   * Linefeed ?
 bne.s gr2p23e
 sub d3,d2                      * Neue Y-Koordinate
 move (a7),d1                   * X an Anfang
bra.s gr2p23a                   * Schleife
gr2p23c:
 lea ztab2(pc),a0               * Sonderzeichen BIT-Feld
 lea ztab0(pc),a4               * Sonderzeichen (ASCII-Code)
 moveq #anztab-2-1,d4           * Anzahl Sonderzeichen
gr2p23d:
 cmp.b (a4)+,d7                 * Gefunden ?
 beq.s gr2p23g                  * Ja !
 addq.l #5,a0                   * Nein, Pointer auf nchstes Zeichen
dbra d4,gr2p23d                 * Bis alle Zeichen durchsucht sind
bra.s gr2p23a                   * Schleife
gr2p23e:
 sub #' ',d7                    * Fr Berechnung aus Tabelle
 bmi.s gr2p23a                  * Negativ, dann kein ASCII-Zeichen
 mulu #5,d7                     * Jedes Zeichen besteht aus 5 Bytes
 lea colztab(pc,d7),a0          * Adresse berechnen
gr2p23g:
 move d3,-(a7)
 bsr gr2p24a                    * Zeichen ausgeben
 move (a7)+,d3
bra.s gr2p23a                   * Schleife

colztab:
 dc.b $00,$00,$00,$00,$00       * Leerzeichen
 dc.b $00,$00,$5f,$00,$00       * !
 dc.b $00,$07,$00,$07,$00       * "
 dc.b $0a,$1f,$0a,$1f,$0a       * #
 dc.b $24,$2a,$7f,$2a,$12       * $
 dc.b $23,$13,$08,$64,$62       * %
 dc.b $36,$49,$55,$22,$50       * &
 dc.b $00,$00,$0b,$07,$00       * '
 dc.b $00,$1c,$22,$41,$00       * (
 dc.b $00,$41,$22,$1c,$00       * )
 dc.b $2a,$1c,$7f,$1c,$2a       * *
 dc.b $08,$08,$3e,$08,$08       * +
 dc.b $00,$00,$b0,$70,$00       * ,
 dc.b $08,$08,$08,$08,$08       * -
 dc.b $00,$60,$60,$00,$00       * .
 dc.b $20,$10,$08,$04,$02       * /
 dc.b $3e,$41,$41,$3e,$00       * 0
 dc.b $00,$02,$7f,$00,$00       * 1
 dc.b $62,$51,$49,$49,$46       * 2
 dc.b $41,$41,$49,$4d,$33       * 3
 dc.b $0f,$08,$08,$7f,$08       * 4
 dc.b $47,$45,$45,$45,$39       * 5
 dc.b $3c,$4a,$49,$49,$30       * 6
 dc.b $61,$11,$09,$05,$03       * 7
 dc.b $36,$49,$49,$49,$36       * 8
 dc.b $06,$49,$49,$29,$1e       * 9
 dc.b $00,$36,$36,$00,$00       * :
 dc.b $00,$b6,$76,$00,$00       * ;
 dc.b $08,$14,$22,$41,$00       * <
 dc.b $14,$14,$14,$14,$14       * =
 dc.b $00,$41,$22,$14,$08       * >
 dc.b $02,$01,$51,$09,$06       * ?
 dc.b $3e,$41,$5d,$55,$5e       * @
 dc.b $7e,$09,$09,$09,$7e       * A
 dc.b $7f,$49,$49,$49,$36       * B
 dc.b $3e,$41,$41,$41,$22       * C
 dc.b $7f,$41,$41,$41,$3e       * D
 dc.b $7f,$49,$49,$49,$41       * E
 dc.b $7f,$09,$09,$09,$01       * F
 dc.b $3e,$41,$49,$49,$3a       * G
 dc.b $7f,$08,$08,$08,$7f       * H
 dc.b $00,$41,$7f,$41,$00       * I
 dc.b $30,$80,$40,$40,$3f       * J
 dc.b $7f,$08,$14,$22,$41       * K
 dc.b $7f,$40,$40,$40,$40       * L
 dc.b $7f,$02,$0c,$02,$7f       * M
 dc.b $7f,$02,$04,$08,$7f       * N
 dc.b $3e,$41,$41,$41,$3e       * O
 dc.b $7f,$09,$09,$09,$06       * P
 dc.b $3e,$41,$51,$21,$5e       * Q
 dc.b $7f,$09,$19,$29,$46       * R
 dc.b $26,$49,$49,$49,$32       * S
 dc.b $01,$01,$7f,$01,$01       * T
 dc.b $3f,$40,$40,$40,$3f       * U
 dc.b $1f,$20,$40,$20,$1f       * V
 dc.b $7f,$20,$18,$20,$7f       * W
 dc.b $63,$14,$08,$14,$63       * X
 dc.b $07,$08,$70,$08,$07       * Y
 dc.b $61,$51,$49,$45,$43       * Z
 dc.b $00,$7f,$41,$41,$00       * [
 dc.b $02,$04,$08,$10,$20       * \
 dc.b $00,$41,$41,$7f,$00       * ]
 dc.b $04,$02,$7f,$02,$04       * ^
 dc.b $08,$1c,$2a,$08,$08       * _
 dc.b $00,$07,$0b,$00,$00       * `
 dc.b $70,$54,$54,$78,$40       * a
 dc.b $40,$7f,$44,$44,$3c       * b
 dc.b $00,$38,$44,$44,$48       * c
 dc.b $38,$44,$44,$7f,$40       * d
 dc.b $00,$38,$54,$54,$48       * e
 dc.b $00,$08,$7c,$0a,$02       * f
 dc.b $00,$98,$a4,$a4,$7c       * g
 dc.b $00,$7f,$04,$04,$78       * h
 dc.b $00,$00,$7a,$00,$00       * i
 dc.b $00,$40,$80,$74,$00       * j
 dc.b $00,$7e,$10,$28,$44       * k
 dc.b $00,$02,$7e,$40,$00       * l
 dc.b $7c,$04,$7c,$04,$7c       * m
 dc.b $00,$7c,$04,$04,$78       * n
 dc.b $00,$38,$44,$44,$38       * o
 dc.b $00,$fc,$24,$24,$18       * p
 dc.b $18,$24,$24,$fc,$80       * q
 dc.b $00,$7c,$08,$04,$04       * r
 dc.b $00,$48,$54,$54,$24       * s
 dc.b $00,$04,$3e,$44,$20       * t
 dc.b $3c,$40,$40,$7c,$40       * u
 dc.b $0c,$30,$40,$30,$0c       * v
 dc.b $3c,$40,$30,$40,$3c       * w
 dc.b $44,$24,$38,$48,$44       * x
 dc.b $00,$1c,$20,$a0,$fc       * y
 dc.b $40,$64,$54,$4c,$04       * z
 dc.b $00,$08,$36,$41,$41       * {
 dc.b $00,$00,$77,$00,$00       * |
 dc.b $00,$41,$41,$36,$08       * }
 dc.b $08,$08,$08,$08,$38       * ~
 dc.b $55,$2a,$55,$2a,$55       * 
 ds 0

gr2p24:                         * Zeichengenerator mit Voreinstellungen
 movem.l d0/d2-d6/a0/a4,-(a7)
 movea.l colpadr(a5),a6
 move.b d3,d0                   * Gre nach d0
 asr #1,d2                      * Bildschirmaufbau beachten
 bsr.s gr2p24a                  * Zeichen ausgeben
 movem.l (a7)+,d0/d2-d6/a0/a4
rts

gr2p24a:                        * Liefert in d1/d2 neue Position
 cmp.b #$11,d0                  * Fr Gre $11 gibt es eine Spezialroutine
 beq.s gr2p240
 move d0,-(a7)                  * d0 merken
 move.b d0,d6
 lsr #4,d6
 and #$f,d6
 subq #1,d6
 and #$f,d6
 move d1,d3
 add d6,d3
 addq #1,d6                     * Abstand der Spalten
 and #$f,d0
 subq #1,d0
 and #$f,d0
 move d0,d7                     * Hhe einer Reihe
 moveq #5-1,d4                  * Breite eines Buchstaben
gr2p24b:
 move.b (a0),d0                 * 8 Punkte holen
 beq.s gr2p24h                  * Null, dann leere Spalte
 move d2,-(a7)
 moveq #8-1,d5                  * Hhe
gr2p24c:
 btst d5,d0                     * Punkt gesetzt ?
 beq.s gr2p24f                  * Nein, dann weiter
 move d7,-(a7)                  * merken
gr2p24d:
 cmp #255,d2                    * Auerhalb des Bereichs ?
 bhi.s gr2p24e                  * Ja, dann nicht zeichnen
 bsr gr2xla                     * Zeichnen
gr2p24e:
 addq #1,d2                     * Y erhhen
dbra d7,gr2p24d
 move.b (a0),d0                 * d0 wieder herstellen
 move (a7)+,d7                  * Zurck
bra.s gr2p24g                   * d2 auf alten Wert
gr2p24f:
 add d7,d2                      * Neue Hhe
 addq #1,d2
gr2p24g:
dbra d5,gr2p24c
 move (a7)+,d2
gr2p24h:
 addq #1,a0                     * Nchste Spalte
 add d6,d1                      * Dazu neue X-Koordinate
 add d6,d3
dbra d4,gr2p24b                 * Neue Spalte
 add d6,d1                      * Dort liegt jetzt neuer Buchstabe
 move (a7)+,d0
rts

gr2p240:                        * Spezialroutine fr Gre $11
 move d1,d5                     * X und Y merken
 move d2,d6
 moveq #5-1,d3                  * 5 Spalten
gr2p240a:
 move.b (a0)+,d7                * Spalte holen
 beq.s gr2p240d                 * Spalte ist leer
 moveq #8-1,d4                  * 8 Punkte pro Spalte
gr2p240b:
 btst d4,d7                     * Punkt setzen ?
 beq.s gr2p240c                 * Nein, dann weiter
 cmp #511,d5
 bhi.s gr2p240c                 * Auerhalb des Bildschirms
 cmp #255,d6
 bhi.s gr2p240c                 * Auerhalb des Bildschirms
 move d5,d1
 move d6,d2                     * Werte fr colpoint
 bsr.s colpoint                 * Punkt setzen
gr2p240c:
 addq #1,d6                     * Neue Y-Koordinate
dbra d4,gr2p240b
 subq #8,d6                     * Y auf alten Wert
gr2p240d:
 addq #1,d5                     * Neue X-Koordinate
dbra d3,gr2p240a
 addq #1,d5
 move d5,d1
 move d6,d2                     * Dort liegt nchster Punkt
rts

grp25:                          * Adressen der Zeichentabellen ermitteln
 lea colztab(pc),a0             * Adresse ASCII-Zeichen
 lea ztab2(pc),a1               * Adresse Sonderzeichen
rts

gr2p29:                         * Adresse der COL-Karte einstellen
 move #$c000,d1                 * Es mu eine Adresse sein, die mit $c000 endet
 move.l d1,colram(a5)           * Adresse merken
rts

colinit:                        * COL initialisieren
 lea colitab(pc),a6             * Adresse der Werte fr 6845
 moveq #14-1,d7                 * 14 Werte
colinit1:
 move.b d7,colcrt.w             * Register whlen
 move.b (a6)+,colcrtd.w         * Wert bertragen
dbra d7,colinit1
colinit2:
 clr d7
 move.b colvpage(a5),d7         * Leseseite
 lsl #8,d7
 add colscroll(a5),d7           * Scroll dazu
 lsl #4,d7                      * Jetzt richtiger Wert
 move.b #13,colcrt.w            * Einstellen des Scrolls
 move.b d7,colcrtd.w            * in zwei Registern
 lsr #8,d7                      * des 6845
 move.b #12,colcrt.w
 move.b d7,colcrtd.w
rts

colitab:                        * Auflsung 256*256 aber mit IBM-Ausgang 512*256
 dc.b 0,0,0,0,3,0,70,64,0,77,7,82,64,111

colpoint:                       * Punkt setzen ohne Randabfrage
 movea.l colram(a5),a4          * Wird spter mit CPU multipliziert
 not.b d2                       * Y-Koordinate umdrehen
 ror #6,d2                      * Seite ermitteln
 or.b colwpage(a5),d2           * Schreibseite dazu
 move.b d2,colpage.w            * Einstellen
 lsr #2,d2                      * Seite weg
 lsr #1,d1                      * X-Koordinate durch zwei
 jmp (a6)                       * Punkt-Setz-Routine aufrufen

colpset:
 bcs.s colpset1                 * Entscheidung, ob gerade oder ungerade
 move.b d1,d2                   * X-Koordinate addieren
 adda d2,a4                     * Zur Basis-Adresse addieren
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b (a4),d2                 * Punkt holen
 and.b #%01010101,d2            * Nur einen Punkt lassen
 or.b colcol1(a5),d2            * Anderen Punkt dazu
 move.b d2,(a4)                 * Punkt abspeichern
rts
colpset1:
 move.b d1,d2                   * X-Koordinate addieren
 adda d2,a4                     * Zur Basis-Adresse addieren
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b (a4),d2                 * Punkt holen
 and.b #%10101010,d2            * Nur einen Punkt lassen
 or.b colcol2(a5),d2            * Anderen Punkt addieren
 move.b d2,(a4)                 * Punkt abspeichern
rts

colpxor:                        * XOR-Verknpfung
 bcs.s colpxor1                 * Wie bei colpset
 move.b d1,d2
 adda d2,a4
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b colcol1(a5),d2          * Farbe holen
 eor.b d2,(a4)                  * Verknpfen
rts
colpxor1:
 move.b d1,d2
 adda d2,a4
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.b colcol2(a5),d2          * Farbe holen
 eor.b d2,(a4)                  * Verknpfen
rts

gr2u1:                          * Rechteck umrandet
 and #$fffe,d4
 subq #1,d4                     * Damit Hhe korrekt ist
 subq #1,d3                     * Damit Breite korrekt ist
 lea -150(a7),a0
 move #5,(a0)+                  * d1/d2 = linke untere Ecke
 move d1,(a0)+                  * d3/d4 = Seitenlngen (immer positiv)
 move d2,(a0)+                  * Erster Eckpunkt
 add d3,d1
 move d1,(a0)+
 move d2,(a0)+                  * Zweiter Eckpunkt
 add d4,d2
 move d1,(a0)+
 move d2,(a0)+                  * Dritter Eckpunkt
 sub d3,d1
 move d1,(a0)+
 move d2,(a0)+                  * Vierter Eckpunkt
 sub d4,d2
 move d1,(a0)+
 move d2,(a0)+                  * Zurck zum ersten Eckpunkt -> Viereck fertig
 lea -150(a7),a0
bra gr2p2                       * Befehl Linienfolge

gr2u2:                          * Elipse leer
 lea -110(a7),a0
 lea 2(a0),a1
 asr #1,d2                      * Bildschirmaufbau beachten
 move d1,(a0)                   * Mittelpunkt X
 movem.w d2-d4,(a1)             * Mittelpunkt Y, Radius X, Radius Y
 move d3,6(a1)                  * Anfangspunkt X
 add d1,6(a1)
 move d2,8(a1)                  * Anfangspunkt Y
 lea sintab+2(pc),a2            * Tabelle fr Sinus
 lea sintab+180(pc),a3          * Tabelle fr Cosinus
 moveq #90-1,d7                 * Nur ein Viertel berechnen / Rest durch Spigeln
gr2u2a:
 move d7,-(a7)
 move -(a3),d1                  * Cosinus holen (Tabelle)
 muls 2(a1),d1                  * Mal X-Radius
 asr.l #8,d1                    * Durch 256
 move (a2)+,d2                  * Sinus aus Tabelle
 muls 4(a1),d2                  * Mal Y-Radius
 asr.l #8,d2                    * Durch 256
 asr.l #1,d2                    * Bildschirmaufbau beachten
 movem.w 6(a1),d3/d4            * Alte Punkte holen
 add (a0),d1                    * Mittelpunkt addieren
 add (a1),d2
 movem.w d1/d2,6(a1)            * Neue Punkte merken
 cmp d1,d3                      * X-Werte gleich ?
 bne.s gr2u2b                   * Nein, dann zeichnen
 cmp d2,d4                      * Y-Werte gleich ?
 beq.s gr2u2c                   * Ja, dann nicht zeichnen
gr2u2b:
 movem d3-d4,-(a7)
 bsr coldraw                    * Erster Quadrant
 movem (a7)+,d3-d4
 move d3,-(a7)
 movem.w 6(a1),d1/d2            * Werte holen
 sub d1,d3
 neg d1
 add (a0),d1                    * X-Werte spiegeln
 add (a0),d1
 neg d3
 add d1,d3
 movem d1/d3/d4,-(a7)
 bsr coldraw                    * Zweiter Quadrant
 movem (a7)+,d1/d3/d4
 move 8(a1),d2
 sub d2,d4
 neg d2
 add (a1),d2                    * Y-Werte spiegeln
 add (a1),d2
 neg d4
 add d2,d4
 movem d2/d4,-(a7)
 bsr coldraw                    * Dritter Quadrant
 movem (a7)+,d2/d4
 move (a7)+,d3
 move 6(a1),d1
 bsr coldraw                    * Vierter Quadrant
gr2u2c:
 move (a7)+,d7
dbra d7,gr2u2a
rts

gr2u3:                          * Elipse ausgefllt
 lea -100(a7),a0                * Merker X-Koordinate
 lea -104(a7),a1                * Merker Y-Koordinate
 asr #1,d2
 move d1,d5                     * Merker X
 move d2,d6                     * Merker Y
 add d3,d1
 movem d1/d2,(a0)
 move d3,d7
 neg d3
 add d5,d3
 bsr gr2xline                   * Linie durch Mittelpunkt, da Spezialfall
 move d7,d3                     * denn diese Linie wird nicht berechnet
 lea sintab+2(pc),a2            * Tabelle fr Sinus
 lea sintab+180(pc),a3          * Tabelle fr Cosinus
 moveq #90-1,d7                 * 90 Grad
gr2u3a:
 move -(a3),d1                  * Sinus
 muls d3,d1                     * Mal X-Radius
 asr.l #8,d1                    * Durch 256
 add d5,d1                      * X-Koordinate berechnet
 move (a2)+,d2                  * Cosinus
 muls d4,d2                     * Mal Y-Radius
 asr.l #8,d2                    * Durch 256
 asr.l #1,d2                    * Durch 2 wegen Bildschirmaufbau
 add d6,d2                      * Y-Koordinate berechnet
 movem d1/d2,(a1)               * X, Y merken
gr2u3b:
 move d2,d0
 sub 2(a0),d0
 beq.s gr2u3d                   * Wenn Delta-Y = 0 , dann Linie nicht zeichnen
 cmp #1,d0
 beq.s gr2u3c                   * Wenn 1, dann zeichnen
 add (a0),d1                    * Sonst arithmetisches Mittel von letzter und
 asr #1,d1                      * dieser Koordinate bis Abstand nur noch 1,
 add 2(a0),d2                   * dadurch werden einige MULS und LSR eingespart
 asr #1,d2
bra.s gr2u3b                    * Wiederholen
gr2u3c:
 move d3,-(a7)                  * Abstand ist 1, jetzt Linie zeichnen
 movem d1/d2,(a0)
 move d5,d3
 add d5,d3
 sub d1,d3                      * Spiegelung an X-Achse
 bsr gr2xline                   * Linie parallel zur X-Achse
 neg d2
 add d6,d2
 add d6,d2                      * d2 an Mittelpunkt gespiegelt
 bsr gr2xline
 move (a7)+,d3
 move 2(a1),d2
 cmp 2(a0),d2                   * Wenn erste Y-Position und entgltig Berechnet
 beq.s gr2u3d                   * bereinstimmen, dann nchsten Punkt berechnen
 move (a1),d1                   * Sonst nchsten Punkt mit alten Winkel
bra.s gr2u3b
gr2u3d:
dbra d7,gr2u3a                  * Neuer Winkel
rts

coldraw:                        * Linie ziehen mit Randberwachung
 cmp d1,d3                      * Von Links nach Rechts ?
 bpl.s coldrawa                 * Ja, dann weiter
 exg d3,d1                      * X tauschen
 exg d4,d2                      * Y tauschen
coldrawa:
 cmp #512,d1                    * Linie zu weit links ?
 bpl.s coldraws                 * Ja, dann Ende
 tst d3                         * Linie zu weit rechts ?
 bmi.s coldraws                 * Ja, dann Ende
 cmp d2,d4
 beq gr2xline                   * Y-Koordinaten gleich, dann Extra-Routine
 bpl.s coldrawc                 * Linie von unten nach oben, dann weiter
 tst d2                         * Linie zu tief ?
 bmi.s coldraws                 * Ja, dann Ende
 cmp #256,d4                    * Linie zu hoch ?
 bpl.s coldraws                 * Ja, dann Ende
 cmp #256,d2                    * d2 im Bildschirm ?
 bmi.s coldrawb                 * Ja, dann weiter
 move d3,d5                     * Jetzt Schnittpunkt mit Y = 255 berechnen
 sub d1,d5                      * Dx
 move d4,d6
 sub d2,d6                      * Dy
 muls d4,d1
 muls d3,d2
 sub.l d2,d1
 move #255,d2                   * Y = 255
 muls d2,d5
 add.l d5,d1
 divs d6,d1                     * X = (255*Dx+X1*Y2-X2*Y1)/Dy
coldrawb:
 tst d4                         * d4 im Bildschirm ?
 bpl.s coldrawe                 * Ja, dann weiter
 move d4,d6                     * Jetzt Schnittpunkt mit Y = 0 berechnen
 sub d2,d6                      * Dy
 neg d3
 muls d2,d3
 muls d1,d4
 add.l d4,d3
 divs d6,d3                     * X = (X1*Y2-X2*Y1)/Dy
 clr d4                         * Y = 0
bra.s coldrawe
coldraws:
rts                             * Ende
coldrawc:
 cmp #256,d2                    * Linie zu hoch ?
 bpl.s coldraws                 * Ja, dann Ende
 tst d4                         * Linie zu tief ?
 bmi.s coldraws                 * Ja, dann Ende
 tst d2                         * d2 im Bildschirm ?
 bpl.s coldrawd                 * Ja, dann weiter
 move d4,d6                     * Jetzt Schnittpunkt mit Y = 0 berechnen
 sub d2,d6                      * Dy
 muls d4,d1
 muls d3,d2
 sub.l d2,d1
 divs d6,d1                     * X = (X1*Y2-X2*Y1)/Dy
 clr d2                         * Y = 0
coldrawd:
 cmp #256,d4                    * d4 im Bildschirm ?
 bmi.s coldrawe                 * Ja, dann weiter
 move d3,d5                     * Jetzt Schnittpunkt mit Y = 255 berechnen
 sub d1,d5                      * Dx
 move d4,d6
 sub d2,d6                      * Dy
 neg d3
 muls d2,d3
 muls d1,d4
 add.l d4,d3
 move #255,d4                   * Y = 255
 muls d4,d5
 add.l d5,d3
 divs d6,d3                     * X = (255*Dx+X1*Y2-X2*Y1)/Dy
coldrawe:
 cmp d1,d3                      * X-Koordinaten gleich ?
 beq.s coldrawg                 * Ja, dann weiter
 tst d1                         * d1 im Bildschirm ?
 bpl.s coldrawf                 * Ja, dann weiter
 move d3,d5                     * Jetzt Schnittpunkt mit X = 0 berechnen
 sub d1,d5                      * Dx
 muls d3,d2
 muls d4,d1
 sub.l d1,d2
 divs d5,d2                     * Y = (X2*Y1-X1*Y2)/Dx
 clr d1                         * X = 0
coldrawf:
 cmp #512,d3                    * d3 im Bildschirm ?
 bmi.s coldrawg                 * Ja, dann weiter
 move d3,d5                     * Jetzt Schnittpunkt mit X = 511 berechnen
 sub d1,d5                      * Dx
 move d4,d6
 sub d2,d6                      * Dy
 neg d4
 muls d1,d4
 muls d2,d3
 add.l d3,d4
 move #511,d3                   * X = 511
 muls d3,d6
 add.l d6,d4
 divs d5,d4                     * Y = (511*Dy+X2*Y1-X1*Y2)/Dx
coldrawg:
 cmp #511,d1                    * d1 im Bildschirm ?
 bhi.s coldraws                 * Nein, dann Ende
 cmp #511,d3                    * d2 im Bildschirm ?
 bhi.s coldraws                 * Nein, dann Ende
 move d3,d5
 sub d1,d5                      * Dx
 move.l #cpu*256,d0             * Adressabstand wenn Y erhht
 move d4,d6
 sub d2,d6                      * Dy
 bpl.s coldrawh
 neg d6                         * Dy mu positiv sein fr Bresenham
 neg.l d0                       * Adressabstand wenn Y erniedrigt
coldrawh:
 move d5,d7
 cmp d6,d7
 bpl.s coldrawi
 move d6,d7
 neg d7                         * Richtungsmerker fr Bresenham
coldrawi:
 move d1,d3                     * X merken
 movea.l colram(a5),a4          * Basis-Adresse COL-Ram
 not.b d2
 ror #6,d2
 or.b colwpage(a5),d2           * Schreibseite bercksichtigen
 move.b d2,colpage.w            * 16 Kbyte-Page einstellen
 move.b d2,d4                   * Seite merken
 lsr #2,d2
 lsr #1,d3                      * d1 durch Zwei, da ein Byte zwei Punkte enthlt
 move.b d3,d2
 adda d2,a4                     * Adresse berechnet
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 move.l #$00008000,d2           * Merker, ob gerader oder ungerader Punkt
 move.b colcol1(a5),d2          * Farbe fr zweiten Punkt
 swap d2
 move.b colcol2(a5),d2          * Farbe fr ersten Punkt
 move.b colxor(a5),d3           * XOR-Mode merken
 movea d6,a6
 adda.l a6,a6                   * Dy*2
 add d5,d6                      * Anzahl der Punkte fr Dbra
 add d5,d5                      * Dx*2
 move.l a5,-(a7)                * a5 darf nicht zerstrt werden
 movea d5,a5
 moveq #%01010101,d5            * Maske1
 swap d5
 move.b #%10101010,d5           * Maske2
 tst.b d3
 beq.s coldrawj
 moveq #$ff,d5                  * Bei Xor-Modus keine Maske
coldrawj:
 lsr #1,d1                      * Gerader oder ungerader Punkt ?
 bcs.s coldrawk                 * Wenn gerade, dann weiter
 swap d2                        * Sonst Farbe wechseln
 swap d5                        * Und Maske wechseln
coldrawk:
 move.l #63*256*cpu,d1          * Grenze zwischen den Pages
 move.b (a4),d3                 * Ersten Punkt holen
 tst d7                         * Richtungsmerker fr Bresenham
 bmi.s coldrawo                 * Zuerst Y verndern
coldrawl:
 and.b d5,d3                    * Maske
 eor.b d2,d3                    * Farbe
dbra d6,coldrawm                * Weiter, wenn nicht Ende
 move.b d3,(a4)                 * Punkt abspeichern
 movea.l (a7)+,a5
rts
coldrawm:
 swap d5                        * Maske wechseln
 swap d2                        * Farbe fr nchsten Punkt
 bmi.s coldrawn                 * Wenn negativ, dann weiter
 move.b d3,(a4)                 * Sonst zwei Punkte abspeichern
 addq.l #cpu,a4                 * Nchster Punkt
 move.b (a4),d3                 * Neue Punkte holen
coldrawn:
 sub a6,d7                      * Richtungsmerker
 bpl.s coldrawl                 * Wenn positiv, dann X verndern
coldrawo:
 and.b d5,d3                    * Maske
 eor.b d2,d3                    * Farbe
 move.b d3,(a4)                 * Punkt immer abspeichern
dbra d6,coldrawp                * Weiter, wenn nicht Ende
 movea.l (a7)+,a5
rts
coldrawp:
 suba.l d0,a4                   * Neue Adresse
 move a4,d3                     * Adresse holen
 tst.l d0                       * Richtung hoch oder runter ?
 bpl.s coldrawq                 * Hoch, dann weiter
 and d1,d3                      * Abfrage, ob Page-Rand erreicht
 bne.s coldrawr                 * Nein, dann weiter
 addq.b #1,d4                   * Neue Seite whlen
 move.b d4,colpage.w            * Einstellen
 suba.l #16*1024*cpu,a4         * Adresse korrigieren
bra.s coldrawr                  * Weiter
coldrawq:
 and d1,d3
 cmp d1,d3                      * Abfrage, ob Page-Rand erreicht
 bne.s coldrawr                 * Nein, dann weiter
 subq.b #1,d4                   * Neue Seite whlen
 move.b d4,colpage.w            * Einstellen
 adda.l #16*1024*cpu,a4         * Adresse korrigieren
coldrawr:
 move.b (a4),d3                 * Neue Punkte holen
 add a5,d7                      * Richtungsmerker
 bpl.s coldrawl                 * X verndern
bra.s coldrawo                  * Y verndern

                                * Linie parallel zur X-Achse ziehen
                                * Mit Randberwachung
gr2xline:                       * d0 wird zerstrt / d1/d3 knnen vertauscht
 cmp #255,d2                    * werden
 bhi.s gr2xlfi                  * Bereichsberschreitung
 cmp d1,d3
 bpl.s gr2xla
 exg d1,d3                      * d3 mu grer als d1 sein
gr2xla:
 cmp #511,d1                    * d1 im Bereich ?
 bls.s gr2xla0                  * Ja, weiter
 bgt.s gr2xlfi                  * Zu gro, deshalb Ende
 tst d3                         * d3 auch kleiner Null ?
 bmi.s gr2xlfi                  * Ja, dann Ende
 clr d1                         * d1 auf Null
gr2xla0:
 cmp #512,d3                    * d3 zu gro ?
 bmi.s gr2xla1                  * Nein, dann weiter
 move #511,d3                   * Maximale Gre
gr2xla1:
 move d1,d0
 movem d1-d6,-(a7)
 movea.l colram(a5),a4          * Basis-Adresse COL
 not.b d2                       * Y-Koordinate umdrehen
 ror #6,d2                      * Seite ermitteln
 or.b colwpage(a5),d2
 move.b d2,colpage.w            * Seite eingestellt
 lsr #2,d2
 lsr #1,d1                      * d1 durch zwei, da ein Byte zwei Punkte enthlt
 move.b d1,d2                   * Adresse berechnen
 adda d2,a4                     * Adresse fertig
 adda.l a4,a4                   * ==> Nur fr 68000/68010
 sub d0,d3                      * Anzahl der Punkte berechnen
 move d3,d6                     * Schleifenzhler
 move.b #%01010101,d1           * Maske
 move.b colcol1(a5),d2          * Farbe
 move.b #%10101010,d3           * Maske
 move.b colcol2(a5),d4          * Farbe
 tst.b colxor(a5)               * Verknpfung ?
 bne.s gr2xld                   * XOR
 move.b (a4),d5
 btst #0,d0                     * Ersten Punkt testen
 bne.s gr2xlc                   * Ungerade
gr2xlb:
 and.b d1,d5                    * Gerader Punkt
 or.b d2,d5                     * Farbe setzen
dbra d6,gr2xlc
 move.b d5,(a4)
 movem (a7)+,d1-d6
gr2xlfi:
rts
gr2xlc:
 and.b d3,d5                    * Ungerader Punkt
 or.b d4,d5                     * Farbe setzen
 move.b d5,(a4)                 * Zwei Punkte abspeichern
 addq.l #cpu,a4
 move.b (a4),d5                 * Zwei neue Punkte holen
dbra d6,gr2xlb
 movem (a7)+,d1-d6
rts
gr2xld:
 btst #0,d0                     * Ersten Punkt testen
 bne.s gr2xlf                   * Ungerade
gr2xle:
 eor.b d2,(a4)                  * Verknpfen
dbra d6,gr2xlf
 movem (a7)+,d1-d6
rts
gr2xlf:
 eor.b d4,(a4)                  * Verknpfen
 addq.l #cpu,a4
dbra d6,gr2xle
 movem (a7)+,d1-d6
rts

ende:                           * Endemarkierung fr Lngenberechnung

df.b 1024*64-*,$ff              * Rest der 64 Kbyte mit $FF fllen

end
